package ui

import (
	"context"
	"fmt"

	def "git.pbiernat.io/egommerce/api-entities/http"
	"git.pbiernat.io/egommerce/api-entities/model"
	"git.pbiernat.io/egommerce/order-service/internal/service"
)

func CreateOrder(srv *service.OrderService, orderID, reqID string) (*model.OrderModel, error) { // FIXME: model.Order
	ctx := context.Background()
	order, _ := srv.GetOrder(ctx, orderID)
	if order != nil {
		srv.Log("order#%s already exists. %v", order.ID, order)
		return nil, fmt.Errorf("order#%s already exists", order.ID)
	}

	order, err := srv.CreateOrder(ctx, orderID)
	if err != nil {
		srv.Log("Failed to create an Order: %s. :: %v\n", err, order)
		return nil, err
	}

	return order, nil
}

func UpdateOrderStatus(srv *service.OrderService, orderID, status, reqID string) (*def.UpdateOrderStatusResponse, error) {
	res := &def.UpdateOrderStatusResponse{}
	_, err := srv.UpdateOrderStatus(reqID, orderID, status)
	if err != nil {
		return res, err
	}

	return res, nil
}
